<?php defined('_JEXEC') or die('Restricted access');

class pm_payanyway extends PaymentRoot{
	
    function showPaymentForm($params, $pmconfigs){
	    self::loadLanguageFile();
        include(dirname(__FILE__) . "/paymentform.php");
    }

	// function call in admin
	function showAdminFormParams($params){
		self::loadLanguageFile();

		$array_params = array('online_payment', 'payment_server', 'mnt_id', 'mnt_dataintegrity_code', 'mnt_test_mode', 'mnt_currency_code');

		foreach ($array_params as $key){
			if (!isset($params[$key])) $params[$key] = '';
		}

		$orders = JModelLegacy::getInstance('orders', 'JshoppingModel'); //admin model
		$currencies = JModelLegacy::getInstance('currencies', 'JshoppingModel'); //admin model

		include(dirname(__FILE__) . "/adminparamsform.php");
	}

    /**
     * Подключение необходимого языкового файла для модуля
     */
    function loadLanguageFile(){
        $lang = JFactory::getLanguage();
        // переменная с полным именем языкового файла (с путём)
        $lang_file = JPATH_ROOT . '/components/com_jshopping/lang/' . $lang->getTag() . '.pm_payanyway.php';
        // пытаемся подключить языковой файл, если такого нет - подключается по-умолчанию (en-GB.php)
        if(file_exists($lang_file))
            require_once $lang_file;
        else
            require_once JPATH_ROOT . '/components/com_jshopping/lang/' . 'en-GB.pm_payanyway.php';
    }

	function checkTransaction($pmconfigs, $order, $act){
		if (isset($_REQUEST['MNT_ID']) && isset($_REQUEST['MNT_TRANSACTION_ID']) && isset($_REQUEST['MNT_OPERATION_ID'])
			&& isset($_REQUEST['MNT_AMOUNT']) && isset($_REQUEST['MNT_CURRENCY_CODE']) && isset($_REQUEST['MNT_TEST_MODE'])
			&& isset($_REQUEST['MNT_SIGNATURE'])) 
		{
			$dataIntegrityCode  = $pmconfigs['mnt_dataintegrity_code'];
			$signature	 = md5("{$_REQUEST['MNT_ID']}{$_REQUEST['MNT_TRANSACTION_ID']}{$_REQUEST['MNT_OPERATION_ID']}{$_REQUEST['MNT_AMOUNT']}{$_REQUEST['MNT_CURRENCY_CODE']}{$_REQUEST['MNT_TEST_MODE']}{$dataIntegrityCode}");
			$amount = number_format(getPriceFromCurrency($order->order_total, $pmconfigs['mnt_currency_code']), 2, '.', '');
			if ($_REQUEST['MNT_SIGNATURE'] == $signature and $amount == $_REQUEST['MNT_AMOUNT']) {

				// echo 'SUCCESS';

			// данные для кассы
			$kassa_inventory = null;
			$kassa_customer = $order->email;
			$kassa_delivery = null;

	                // пробить чек
                        $products = $order->getAllItems();

	                // товары
	                if (is_array($products) && count($products)) {
	                    $inventoryPositions = array();
	                    foreach ($products AS $product) {
	                        $inventoryPositions[] = array('name' => trim(preg_replace("/&?[a-z0-9]+;/i", "", htmlspecialchars($product->product_name))), 'price' => $product->product_item_price, 'quantity' => $product->product_quantity, 'vatTag' => 1105);
	                    }
		            $kassa_inventory = $inventoryPositions;
	                }

			if (is_array($kassa_inventory) && $kassa_customer) {
				$kassa_inventory = json_encode($kassa_inventory);
				$resultCode = '200';
				header("Content-type: application/xml");
				$signature = md5($resultCode . $_REQUEST['MNT_ID'] . $_REQUEST['MNT_TRANSACTION_ID'] . $dataIntegrityCode);
				$result = '<?xml version="1.0" encoding="UTF-8" ?>';
				$result .= '<MNT_RESPONSE>';
				$result .= '<MNT_ID>' . $_REQUEST['MNT_ID'] . '</MNT_ID>';
				$result .= '<MNT_TRANSACTION_ID>' . $_REQUEST['MNT_TRANSACTION_ID'] . '</MNT_TRANSACTION_ID>';
				$result .= '<MNT_RESULT_CODE>' . $resultCode . '</MNT_RESULT_CODE>';
				$result .= '<MNT_SIGNATURE>' . $signature . '</MNT_SIGNATURE>';

				if ($kassa_inventory || $kassa_customer || $kassa_delivery) {
				        $result .= '<MNT_ATTRIBUTES>';
				}

				if ($kassa_inventory) {
				        $result .= '<ATTRIBUTE>';
				        $result .= '<KEY>INVENTORY</KEY>';
				        $result .= '<VALUE>' . $kassa_inventory . '</VALUE>';
				        $result .= '</ATTRIBUTE>';
				}

				if ($kassa_customer) {
				        $result .= '<ATTRIBUTE>';
				        $result .= '<KEY>CUSTOMER</KEY>';
				        $result .= '<VALUE>' . $kassa_customer . '</VALUE>';
				        $result .= '</ATTRIBUTE>';
				}

				if ($kassa_delivery) {
				        $result .= '<ATTRIBUTE>';
				        $result .= '<KEY>DELIVERY</KEY>';
				        $result .= '<VALUE>' . $kassa_delivery . '</VALUE>';
				        $result .= '</ATTRIBUTE>';
				}

				if ($kassa_inventory || $kassa_customer || $kassa_delivery) {
				        $result .= '</MNT_ATTRIBUTES>';
				}

				$result .= '</MNT_RESPONSE>';

				echo $result;

			}
			else {
			    echo 'SUCCESS';
			}


                	return array(1, $_REQUEST['MNT_TRANSACTION_ID']);

			} else {
				echo 'FAIL';
				return array(0, $_REQUEST['MNT_TRANSACTION_ID']);
			}
		} else {
			echo 'FAIL';
			return array(0, $_REQUEST['MNT_TRANSACTION_ID']);
		}
	}

	function showEndForm($pmconfigs, $order){
        
        $pm_method = JTable::getInstance('paymentMethod', 'jshop');
        $payment_method_id = $order->payment_method_id;
        $pm_method->load($payment_method_id);

        $uri = JURI::getInstance();        
        $liveurlhost = $uri->toString(array("scheme",'host', 'port'));
		$currencies = JSFactory::getAllCurrency();
		
		$formParams = array();
		$formParams["MNT_ID"] = $pmconfigs['mnt_id'];
		$formParams["MNT_TRANSACTION_ID"] = $order->order_id;
		$formParams["MNT_TEST_MODE"] = $pmconfigs['mnt_test_mode'];
		$formParams["MNT_AMOUNT"] = number_format(getPriceFromCurrency($order->order_total, $pmconfigs['mnt_currency_code']), 2, '.', '');
		$formParams["MNT_CURRENCY_CODE"] = ($currencies[$pmconfigs['mnt_currency_code']]->currency_code_iso == 'RUR') ? 'RUB' : 'RUB';
		$formParams["MNT_SIGNATURE"]  = md5($pmconfigs['mnt_id'].$order->order_id.$formParams["MNT_AMOUNT"].$formParams["MNT_CURRENCY_CODE"].$pmconfigs['mnt_test_mode'].$pmconfigs['mnt_dataintegrity_code']);
		$formParams["MNT_DESCRIPTION"] = "Заказ номер $order->order_number";
		$formParams["js_paymentclass"] = $pm_method->payment_class;
        $formParams["followup"] = "true";
        $formParams["javascriptEnabled"] = "true";

        $host = "https://".$pmconfigs['payment_server']."/assistant.htm";
        $formParams["MNT_SUCCESS_URL"] = $liveurlhost.SEFLink("index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=".$pm_method->payment_class);
        $formParams["MNT_FAIL_URL"] = $liveurlhost.SEFLink("index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=".$pm_method->payment_class);

        ?>

        <html>
        <body>
        <head>
            <meta http-equiv="content-type" content="text/html; charset=utf-8" />            
        </head>
        <form id="paymentform" action="<?php print $host?>" name = "paymentform" method = "post">
			<?php foreach ($formParams as $key=>$value): ?>
				<input type='hidden' name='<?php print $key; ?>' value='<?php print $value; ?>'/>
			<?php endforeach; ?>
        </form>        
        <?php print _JSHOP_REDIRECT_TO_PAYMENT_PAGE ?>
        <br>
        <script type="text/javascript">document.getElementById('paymentform').submit();</script>
        </body>
        </html>
        <?php
        die();
	}
	
    function getUrlParams($pmconfigs){                        
        $params = array(); 
        $params['order_id'] = JRequest::getInt("MNT_TRANSACTION_ID");
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = $pmconfigs['checkdatareturn'];
		
		return $params;
    }
    
}
